﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace FlexScrollableText
{
  public partial class Form1 : Form
  {
        [DllImport("user32")]
        private static extern bool HideCaret(IntPtr hWnd);
        private TextBox textBoxForDisplay;
    public Form1()
    {
      InitializeComponent();

      this.c1FlexGrid1.Rows.DefaultSize = 40;

      for (int intRow = this.c1FlexGrid1.Rows.Fixed; intRow < this.c1FlexGrid1.Rows.Count; intRow++)
      {
        for (int intCol = this.c1FlexGrid1.Cols.Fixed; intCol < this.c1FlexGrid1.Cols.Count; intCol++)
        {
          string text = $"row {intRow}, col {intCol}";

          if (intCol == 2)
          {
            text = "[0] " + text + Environment.NewLine + "[1] " + text + Environment.NewLine + "[2] " + text + Environment.NewLine + "[3] " + text + Environment.NewLine + "[4] " + text + Environment.NewLine + "[5] " + text;
          }
          this.c1FlexGrid1[intRow, intCol] = text;
        }
      }

      //Create preview textbox:
      this.textBoxForDisplay = new TextBox();
      this.textBoxForDisplay.ScrollBars = ScrollBars.Both;
      this.textBoxForDisplay.Multiline = true;
      //Make it readonly:
      this.textBoxForDisplay.ReadOnly = true;
      //No word wrap?
      //this.textBoxForDisplay.WordWrap = false;

      this.c1FlexGrid1.Controls.Add(this.textBoxForDisplay);
      //Hide it:
      this.textBoxForDisplay.Visible = false;
            this.textBoxForDisplay.GotFocus += TextBoxForDisplay_GotFocus;
    }

        private void TextBoxForDisplay_GotFocus(object sender, EventArgs e)
        {

            if (textBoxForDisplay.ReadOnly == true)
            {
                HideCaret(textBoxForDisplay.Handle);
            }
        }

        private void C1FlexGrid1_AfterSelChange(object sender, C1.Win.C1FlexGrid.RangeEventArgs e)
    {
      //In col 2, show textbox:
      if (e.NewRange.LeftCol == 2)
      {
        this.textBoxForDisplay.Visible = true;

        //Position of cell:
        Rectangle rectCell = this.c1FlexGrid1.GetCellRect(e.NewRange.TopRow, e.NewRange.LeftCol);

        this.textBoxForDisplay.Location = rectCell.Location;
        this.textBoxForDisplay.Size = rectCell.Size;

        //Write Text to textbox:
        this.textBoxForDisplay.Text = (string)this.c1FlexGrid1[e.NewRange.TopRow, e.NewRange.LeftCol];
      }
      else
      {
        this.textBoxForDisplay.Visible = false;
      }
    }
  }
}
